// Include files
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Defines
#define MYAPP "creatFileBigHole "
#define NEWFILE "filebighole"
#define NBYTES  (1024*1024*1024)  // 1 GB

// Main function
// Create a file with a hole inside using lseek
int main(int argc, char **argv)
{
  int fd;
  int n, nw;
  char buf1[8]="ABCD";
  char buf2[8]="1234";
  
  // delete file to create the precondition of this test procedure
  // unlink() returns error also if the input file does not exist,
  //  but for us it is fine, so error is not checked!
  unlink(NEWFILE);

  printf("\n");
  
  //------------------------
  printf("%s: creating a new file \"%s\" using O_RDWR | O_CREAT and 0660 mode ...\n",
	 MYAPP,NEWFILE);
  if ((fd=open(NEWFILE,O_RDWR | O_CREAT,0660)) == -1) {
    perror(MYAPP "ERROR");
  }
  else {
    printf("%s: file has been opened with fd=%d\n",MYAPP,fd);
  }

  // Display info about the file
  printf("%s: File information:\n",MYAPP);
  printf("-------------------------------------\n");
  system("ls -l " NEWFILE);
  printf("-------------------------------------\n");

  // Display info about the filesystem usage
  printf("%s: Filesystem usage:\n",MYAPP);
  printf("-------------------------------------\n");
  system("df -k .");
  printf("-------------------------------------\n");

  // Display info about the disk usage of the file filebighole
  printf("%s: Disk usage:\n",MYAPP);
  printf("-------------------------------------\n");
  system("du -sk " NEWFILE);
  printf("-------------------------------------\n");

  // write some stuff 
  printf("%s: write \"%s\" into file\n",MYAPP,buf1);
  n=strlen(buf1);
  if ((nw=write(fd,buf1,n)) != n)
    printf(MYAPP "ERROR: only %d bytes written to fd=%d (instead of %d bytes)\n",
	   nw, fd, n);
  
  // move offset many bytes ahead 
  printf("%s: moving current file offset ahead of %d Kbytes (%d Mbytes)\n",
	 MYAPP,NBYTES/1024,NBYTES/(1024*1024));
  if (lseek(fd,NBYTES,SEEK_CUR) == -1)
    printf(MYAPP "ERROR");
  
  // write some other stuff 
  printf("%s: write \"%s\" into file\n",MYAPP,buf2);
  n=strlen(buf2);
  if ((nw=write(fd,buf2,n)) != n)
    printf(MYAPP "ERROR: only %d bytes written to fd=%d (instead of %d bytes)\n",
	   nw, fd, n);

  printf("%s: now closing fd=%d\n",MYAPP,fd);
  close(fd);

  // Display info about the file
  printf("%s: File information:\n",MYAPP);
  printf("-------------------------------------\n");
  system("ls -l " NEWFILE);
  printf("-------------------------------------\n");

  // Display info about the filesystem usage
  printf("%s: Filesystem usage:\n",MYAPP);
  printf("-------------------------------------\n");
  system("df -k .");
  printf("-------------------------------------\n");

  // Display info about the disk usage of the file filebighole
  printf("%s: Disk usage:\n",MYAPP);
  printf("-------------------------------------\n");
  system("du -sk " NEWFILE);
  printf("-------------------------------------\n");

  exit(EXIT_SUCCESS);
}
