#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>

#define PRINT_HELP printf("Usage: %s <file1> [file2] ...\n", argv[0])

static const char *file_get_type(struct stat *buf);
static void file_get_perm(struct stat *buf, char *perm);

int main(int argc, char *argv[]) { 
  int i; 
  struct stat buf;
  char perm[10]; /* Permessi sul file: rwxrwxrwx\0 */

  if (argc < 2) {
        PRINT_HELP;
        exit(-1);
  }
  
  for (i = 1; i < argc; i++) { 

	/* Leggi le informazioni sul file */
	if (/* usa lstat */) < 0) { 
	  perror(argv[i]); 
	  continue; 
	}

	printf("%s: ", argv[i]);

	/* Stampa il tipo di file */
	printf("%s ", file_get_type(&buf));

	/* Stampa UID e GID */
	printf("UID=%d GID=%d ", /*... */);

	/* Stampa i permessi sul file */
	file_get_perm(&buf, perm);
	printf("(%s) ", perm);

	/* Stampa data e ora dell'ultima modifica */
	printf("%s", /* ... */);
  }

  return 0;
}

/* Tipo del file */
#define TYPE_REG "regular"
#define TYPE_DIR "directory"
#define TYPE_CHR "character special"
#define TYPE_BLK "block special"
#define TYPE_FIF "fifo"
#define TYPE_SYM "symbolic link"
#define TYPE_SCK "socket"
#define TYPE_UNK "** unknown mode **"

static const char *file_get_type(struct stat *buf) {
  /* Ritorna il tipo del file:
	 TYPE_REG, TYPE_DIR, ..., TYPE_UNK */
  /* ... */
}

#define PERM(x,c) ((buf->st_mode & (x)) ? (c) : '-')

static void file_get_perm(struct stat *buf, char *perm) {
/* Puoi usare la macro PERM */
/* ... */
}
