#ifndef __matrix_h__
#define __matrix_h__

#include <stdio.h>

struct matrix_header {
  int rows; /* Numero di righe della matrice   */
  int cols; /* Numero di colonne della matrice */
};

/*
 * Genera una matrice di dimensione r*c sul file 'filename'
 * In caso di errore ritorna -1, altrimenti 0.
 */
int matrix_generate(const char *filename, int r, int c);

/*
 * Stampa la matrice presente sul file 'filename'
 * In caso di errore ritorna -1, altrimenti 0.
 */
int matrix_print(const char *filename);

/*
 * Esegue un test sui dati della matrice per rilevare
 * eventuali errori di implementazione
 * In caso di errore ritorna -1, altrimenti 0.
 */
int matrix_check(const char *filename);

#endif /* !__matrix_h__ */
